VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CToolTip"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Declare Function OleTranslateColor Lib "OLEPRO32.DLL" (ByVal OLE_COLOR As Long, ByVal HPALETTE As Long, pccolorref As Long) As Long
Private Const CLR_INVALID = -1

'Initialization of New ClassNames
Private Const ICC_BAR_CLASSES = &H4      'toolbar, statusbar, trackbar, tooltips
Private Declare Sub InitCommonControls Lib "comctl32.dll" ()
Private Declare Function InitCommonControlsEx Lib "comctl32.dll" (lpInitCtrls As tagINITCOMMONCONTROLSEX) As Boolean

Private Type tagINITCOMMONCONTROLSEX
   dwSize As Long   ' size of this structure
   dwICC As Long    ' flags indicating which classes to be initialized.
End Type

' ToolTip Styles
Private Const TTS_ALWAYSTIP = &H1
Private Const TTS_NOPREFIX = &H2
Private Const TTS_BALLOON = &H40 ' comctl32.dll v5.8 require

Private Const CW_USEDEFAULT = &H80000000

Private Const WM_USER = &H400

' ToolTip Messages
Private Const TTM_SETDELAYTIME = (WM_USER + 3)
Private Const TTM_ADDTOOL = (WM_USER + 4)
Private Const TTM_DELTOOL = (WM_USER + 5)
Private Const TTM_NEWTOOLRECT = (WM_USER + 6)
Private Const TTM_GETTOOLINFO = (WM_USER + 8)
Private Const TTM_SETTIPBKCOLOR = (WM_USER + 19)
Private Const TTM_SETTIPTEXTCOLOR = (WM_USER + 20)
Private Const TTM_SETMAXTIPWIDTH = (WM_USER + 24)
Private Const TTDT_AUTOPOP = 2
Private Const TTDT_INITIAL = 3

Private Const TTM_TRACKACTIVATE = (WM_USER + 17)
Private Const TTM_TRACKPOSITION = (WM_USER + 18)
Private Const TTM_SETTOOLINFOA = (WM_USER + 9)

Private Const TTF_IDISHWND = &H1
Private Const TTF_CENTERTIP = &H2
Private Const TTF_SUBCLASS = &H10

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type TOOLINFO
    cbSize      As Long
    uFlags      As Long
    hwnd        As Long
    uId         As Long
    cRect       As RECT
    hinst       As Long
    lpszText    As String
End Type

Public Enum TTStyle
    ttStyleStandard = 1
    ttStyleBalloon = 2
End Enum

Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Const GWL_STYLE = (-16)
Private hTT As Long
Dim TI As TOOLINFO
   
Private mvarObjHwnd As Long ' local copy

Public Property Let TxtColor(ByVal clrData As OLE_COLOR)
  SendMessageLong hTT, TTM_SETTIPTEXTCOLOR, TranslateColor(clrData), 0&
End Property

Public Property Let BkColor(ByVal clrData As OLE_COLOR)
  SendMessageLong hTT, TTM_SETTIPBKCOLOR, TranslateColor(clrData), 0&
End Property

Public Property Let VisibleTime(ByVal lData As Long)
   SendMessageLong hTT, TTM_SETDELAYTIME, TTDT_AUTOPOP, lData
End Property

Public Property Let DelayTime(ByVal lData As Long)
    SendMessageLong hTT, TTM_SETDELAYTIME, TTDT_INITIAL, lData
End Property

Public Property Let TipWidth(ByVal lData As Long)
   SendMessageLong hTT, TTM_SETMAXTIPWIDTH, 0, lData
End Property

Public Property Let Style(ByVal ttsData As TTStyle)
   Dim lStyle As Long
   If hTT Then
      lStyle = GetWindowLong(hTT, GWL_STYLE)
      If ttsData = ttStyleBalloon Then lStyle = lStyle Or TTS_BALLOON
      If ttsData = ttStyleStandard And (lStyle And ttStyleBalloon) Then lStyle = lStyle Xor TTS_BALLOON
      SetWindowLong hTT, GWL_STYLE, lStyle
   End If
End Property

Private Sub InitComctl32(dwFlags As Long)
   Dim icc As tagINITCOMMONCONTROLSEX
   On Error GoTo Err_OldVersion
   icc.dwSize = Len(icc)
   icc.dwICC = dwFlags
   InitCommonControlsEx icc
   On Error GoTo 0
   Exit Sub
Err_OldVersion:
   InitCommonControls
End Sub

Public Sub InitToolTip(ByVal ObjHwnd As Long, Optional ByVal sTipText As String = "tooltip", Optional bCenter As Boolean = False)
   mvarObjHwnd = ObjHwnd
   
   With TI
      .hwnd = mvarObjHwnd
      .uFlags = TTF_IDISHWND Or TTF_SUBCLASS
      If bCenter Then
         .uFlags = .uFlags Or TTF_CENTERTIP
      End If
      .uId = mvarObjHwnd
      .lpszText = sTipText
      .cbSize = Len(TI)
   End With
   SendMessage hTT, TTM_ADDTOOL, 0, TI
End Sub

Public Sub RemoveToolTip()
   SendMessage hTT, TTM_DELTOOL, 0, TI
End Sub

Private Sub Class_Initialize()
   InitComctl32 ICC_BAR_CLASSES
   hTT = CreateWindowEx(0, "tooltips_class32", 0&, TTS_NOPREFIX Or TTS_ALWAYSTIP, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 0&, 0&, App.hInstance, 0&)
   Style = ttStyleStandard
   TipWidth = 3000 ' Specify tip width to enable multiline tooltip
End Sub

Private Sub Class_Terminate()
   If hTT Then DestroyWindow hTT
End Sub

Private Function TranslateColor(ByVal oClr As OLE_COLOR, _
                        Optional hPal As Long = 0) As Long
    ' Convert Automation color to Windows color
    If OleTranslateColor(oClr, hPal, TranslateColor) Then
        TranslateColor = CLR_INVALID
    End If
End Function

Public Sub TrackPosition(ByVal x As Integer, ByVal y As Integer)
   SendMessageLong hTT, TTM_TRACKPOSITION, 0&, y * 65536 + x
End Sub

Public Sub ActivateTracking()
   SendMessage hTT, TTM_TRACKACTIVATE, 1, TI
End Sub

Public Sub DeactivateTracking()
   SendMessage hTT, TTM_TRACKACTIVATE, 0, TI
End Sub

Public Sub SetTooltipText(sText As String)
   TI.lpszText = sText
   SendMessage hTT, TTM_SETTOOLINFOA, 0&, TI
End Sub
